package com.zhongzheng.modules.user.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.user.bo.UserExamGoodsSupplementAddBo;
import com.zhongzheng.modules.user.bo.UserExamGoodsSupplementQueryBo;
import com.zhongzheng.modules.user.bo.UserExamGoodsSupplementEditBo;
import com.zhongzheng.modules.user.domain.UserExamGoodsSupplement;
import com.zhongzheng.modules.user.mapper.UserExamGoodsSupplementMapper;
import com.zhongzheng.modules.user.vo.UserExamGoodsSupplementVo;
import com.zhongzheng.modules.user.service.IUserExamGoodsSupplementService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 用户下这个商品的考试次数，前培次数增加Service业务层处理
 *
 * @author ruoyi
 * @date 2021-12-07
 */
@Service
public class UserExamGoodsSupplementServiceImpl extends ServiceImpl<UserExamGoodsSupplementMapper, UserExamGoodsSupplement> implements IUserExamGoodsSupplementService {

    @Override
    public UserExamGoodsSupplementVo queryById(Long id){
        UserExamGoodsSupplement db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, UserExamGoodsSupplementVo.class);
    }

    @Override
    public List<UserExamGoodsSupplementVo> queryList(UserExamGoodsSupplementQueryBo bo) {
        LambdaQueryWrapper<UserExamGoodsSupplement> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getUserExamGoodsId() != null, UserExamGoodsSupplement::getUserExamGoodsId, bo.getUserExamGoodsId());
        lqw.eq(bo.getGoodsId() != null, UserExamGoodsSupplement::getGoodsId, bo.getGoodsId());
        lqw.eq(bo.getStatus() != null, UserExamGoodsSupplement::getStatus, bo.getStatus());
        lqw.eq(bo.getExamNumber() != null, UserExamGoodsSupplement::getExamNumber, bo.getExamNumber());
        lqw.eq(bo.getDoNumber() != null, UserExamGoodsSupplement::getDoNumber, bo.getDoNumber());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<UserExamGoodsSupplementVo> entity2Vo(Collection<UserExamGoodsSupplement> collection) {
        List<UserExamGoodsSupplementVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, UserExamGoodsSupplementVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<UserExamGoodsSupplement> page = (Page<UserExamGoodsSupplement>)collection;
            Page<UserExamGoodsSupplementVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(UserExamGoodsSupplementAddBo bo) {
        UserExamGoodsSupplement add = BeanUtil.toBean(bo, UserExamGoodsSupplement.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(UserExamGoodsSupplementEditBo bo) {
        UserExamGoodsSupplement update = BeanUtil.toBean(bo, UserExamGoodsSupplement.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(UserExamGoodsSupplement entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
